:man_page: mongoc_database_read_write_command_with_opts

mongoc_database_read_write_command_with_opts()
==============================================

Synopsis
--------

.. code-block:: c

  bool
  mongoc_database_read_write_command_with_opts (
     mongoc_database_t *database,
     const bson_t *command,
     const mongoc_read_prefs_t *read_prefs /* UNUSED */,
     const bson_t *opts,
     bson_t *reply,
     bson_error_t *error);

Execute a command on the server, applying logic for commands that both read and write, and taking the MongoDB server version into account. To send a raw command to the server without any of this logic, use :symbol:`mongoc_database_command_simple`.

.. |opts-source| replace:: ``database``

.. include:: includes/read-write-opts-sources.txt

``reply`` is always initialized, and must be freed with :symbol:`bson:bson_destroy()`.

(The :symbol:`mongoc_read_prefs_t` parameter was included by mistake when this function was introduced in libmongoc 1.5. A command that writes must not obey a read preference.)

Parameters
----------

* ``database``: A :symbol:`mongoc_database_t`.
* ``command``: A :symbol:`bson:bson_t` containing the command specification.
* ``read_prefs``: Ignored.
* ``opts``: A :symbol:`bson:bson_t` containing additional options.
* ``reply``: A location for the resulting document.
* ``error``: An optional location for a :symbol:`bson_error_t <errors>` or ``NULL``.

.. include:: includes/read-write-opts.txt

Consult `the MongoDB Manual entry on Database Commands <https://docs.mongodb.com/manual/reference/command/>`_ for each command's arguments.

Errors
------

Errors are propagated via the ``error`` parameter.

Returns
-------

Returns ``true`` if successful. Returns ``false`` and sets ``error`` if there are invalid arguments or a server or network error.

A write concern timeout or write concern error is considered a failure.

Example
-------

See the example code for :symbol:`mongoc_client_read_command_with_opts`.

